use poise::serenity_prelude as serenity;
use dotenv;
mod command;

pub struct Data {} // User data, which is stored and accessible in all command invocations
type Context<'a> = poise::Context<'a, Data, anyhow::Error>;

#[tokio::main]
async fn main() {
    dotenv::dotenv().ok();
    let token = std::env::var("DISCORD_TOKEN").expect("missing DISCORD_TOKEN");

    println!(r#"

     /$$$$$$$$                                /$$             /$$                     /$$$$$$$              /$$    
    |__  $$__/                               | $$            | $$                    | $$__  $$            | $$    
       | $$  /$$$$$$  /$$$$$$/$$$$   /$$$$$$ | $$  /$$$$$$  /$$$$$$    /$$$$$$       | $$  \ $$  /$$$$$$  /$$$$$$  
       | $$ /$$__  $$| $$_  $$_  $$ /$$__  $$| $$ |____  $$|_  $$_/   /$$__  $$      | $$$$$$$  /$$__  $$|_  $$_/  
       | $$| $$$$$$$$| $$ \ $$ \ $$| $$  \ $$| $$  /$$$$$$$  | $$    | $$$$$$$$      | $$__  $$| $$  \ $$  | $$    
       | $$| $$_____/| $$ | $$ | $$| $$  | $$| $$ /$$__  $$  | $$ /$$| $$_____/      | $$  \ $$| $$  | $$  | $$ /$$
       | $$|  $$$$$$$| $$ | $$ | $$| $$$$$$$/| $$|  $$$$$$$  |  $$$$/|  $$$$$$$      | $$$$$$$/|  $$$$$$/  |  $$$$/
       |__/ \_______/|__/ |__/ |__/| $$____/ |__/ \_______/   \___/   \_______/      |_______/  \______/    \___/  
                                   | $$                                                                            
                                   | $$                                                                            
                                   |__/                                                                            
                                                                                                                        
    Template Bot.
    Invite this bot with:
    
    "#);
    
    let intents =
        serenity::GatewayIntents::GUILD_VOICE_STATES |
        serenity::GatewayIntents::non_privileged();


    let framework = poise::Framework::builder()
        .options(poise::FrameworkOptions {
            commands: vec![
                command::example(),
            ],
            ..Default::default()
        })
        // un-comment songbird from Cargo.toml first.
        //.client_settings(songbird::register)
        .token(token)
        .intents(intents)
        .setup(|ctx, _ready, framework| {
            Box::pin(async move {
                poise::builtins::register_globally(ctx, &framework.options().commands).await?;

                Ok(Data {})
            })
        });
    
    framework.build().await.unwrap().start().await.unwrap();
}

